routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ForumController;
use App\Http\Controllers\AccueilController;
use App\Http\Controllers\CommentaireController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [AccueilController::class, 'index']);


Route::get('/details/{forum}', [AccueilController::class, 'detail'])->name('forum.detail');



Route::resource('commentaire', CommentaireController::class); 
Route::group(['middleware'=>['auth']], function(){
    Route::resource('forum', ForumController::class); 
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Commentaire.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Commentaire extends Model
{
    use HasFactory;

    protected $fillable = ['commentaire','user_id','forum_id'];

    public function user(){
        return $this->belongsTo(User::class);
    }
    public function forum(){
        return $this->belongsTo(Forum::class);
    }
}

app/Models/Forum.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Forum extends Model
{
    use HasFactory;

    protected $fillable = ['titre','description','image','date'];

    public function commentaires ()
    {
        return $this->hasMany(Commentaire::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/AccueilController.php
<?php

namespace App\Http\Controllers;

use App\Models\Commentaire;
use App\Models\Forum;
use Illuminate\Http\Request;

class AccueilController extends Controller
{
    public function index(){
        $forums = Forum::limit(4)->latest()->get();
        return view('index', [
            'forums' => $forums
        ]);
    }

    public function detail(Forum $forum){
        return view('detail', compact('forum'));
    }
}

app/Http/Controllers/CommentaireController.php
<?php

namespace App\Http\Controllers;

use App\Models\Commentaire;
use Illuminate\Http\Request;

class CommentaireController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'commentaire'=>'required|min:3'
        ]);


        Commentaire::create([
            'commentaire'=>$request->commentaire,
            'forum_id'=>$request->forum_id,
            'user_id'=>auth()->user()->id,
        ]);

        return back();
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Commentaire  $commentaire
     * @return \Illuminate\Http\Response
     */
    public function show(Commentaire $commentaire)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Commentaire  $commentaire
     * @return \Illuminate\Http\Response
     */
    public function edit(Commentaire $commentaire)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Commentaire  $commentaire
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Commentaire $commentaire)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Commentaire  $commentaire
     * @return \Illuminate\Http\Response
     */
    public function destroy(Commentaire $commentaire)
    {
        //
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ForumController.php
<?php

namespace App\Http\Controllers;

use App\Models\Forum;
use Illuminate\Http\Request;
use Alert;

class ForumController extends Controller
{
    public function index(){
        $forums = Forum::paginate(10);
        return view('forum.index', compact('forums'));
    }

    public function create(){
        $forum = new Forum();
        return view('forum.create', compact('forum'));
    }

    public function store(Request $request){
        $this->validate($request, [
            'titre'=> 'required',
            'description'=> 'required|min:5',
            'date'=> 'required|date',
            'image'=> 'required|mines:jpg,png',
        ]);
        try {

            $image = $request->file('image');
            $nouveau_nom = uniqid().".".$image->getClientOriginalExtension();
            $image->storeAs('forum', $nouveau_nom, 'public');
            
            Forum::create([
                'titre' => $request->titre,
                'description' => $request->description,
                'date' => $request->date,
                'image' => $nouveau_nom,
            ]);

        }
        catch(\Exception $e)
        {
            dd($e);
        }

        Alert::success('Forum','Ajouté avec succès');
        return redirect()->route('forum.index');
    }

    public function edit(Forum $forum){
        return view('forum.edit', compact('forum'));
    }

    public function update(Request $request, Forum $forum){
        
        $this->validate($request, [
            'titre'=> 'required',
            'description'=> 'required|min:5',
            'date'=> 'required|date',
        ]);
        try {
            
            $forum->update([
                'titre' => $request->titre,
                'description' => $request->description,
                'date' => $request->date
            ]);
            
            if(isset($request->image))
            {
                $image = $request->file('image');
                $nouveau_nom = uniqid().".".$image->getClientOriginalExtension();
                $image->storeAs('forum', $nouveau_nom, 'public');
                $forum->update([
                    'image' => $nouveau_nom,
                ]);
            }

        }
        catch(\Exception $e)
        {
            dd($e);
        }

        Alert::success('Forum','Mise à jour avec succès');
        return redirect()->route('forum.index');
    }

    public function destroy(Forum $forum){
        $forum->delete();
        Alert::success('Forum','Suppression éffectué avec succès');
        return redirect()->route('forum.index');
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

resources/views/detail.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div style="display:flex;width:100%;height:350px;background:url('{{asset('storage/forum/'. $forum->image)}}');backgound-repeat:no-repeat;background-size:cover">
        
    </div>
    <h1>{{$forum->titre}}</h1>
    <p>
        {{$forum->description}}
    </p>
    <hr>
    <div>
        <div class="commentaire">
            <h2>Commentaires {{\App\Models\Commentaire::where('forum_id', $forum->id)->count()}}</h2>
           
            @foreach($forum->commentaires()->latest()->get() as $commentaire)

            <div class="comment {{ auth()->user()->id==$commentaire->user->id ? 'moi':''}}">
                <p>{{$commentaire->user->name}}</p>
                <p>{{$commentaire->commentaire}}</p>
            </div>
            @endforeach

        </div>
        <hr>
        <div>
            <form action="{{route('commentaire.store')}}" method="POST">
                @csrf 
                <input type="hidden" name="forum_id" value="{{$forum->id}}">
                <div class="form-control">
                    <label for="commentaire">Commentaire</label>
                    <textarea placeholder="Votre commentaire" name="commentaire" id="commentaire" class="form-control" cols="30" rows="10"></textarea>
                </div>

                <input type="submit" value="Envoyer" class="btn btn-success btn-block">
            </form>
        </div>
    </div>

</div>

@endsection


@section('css')
    <style>
        .comment {
            background:rgba(115, 115, 131, 0.263);
            width:80%;
        }

        .moi {
           margin-left:20%;
        }
    </style>
@endsection

resources/views/forum/_form.blade.php
<div class="form-group my-2">
    <label for="titre">Titre</label>
    <input type="text" name="titre" value="{{old('titre') ? old('titre') : $forum->titre}}" id="titre" class="form-control" >
    @error('titre') <span style="color:red">{{$message}}</span>@enderror
</div>
<div class="form-group my-2">
    <label for="description">Description</label>
    <textarea name="description" id="description" class="form-control"  cols="30" rows="3">{{old('description') ? old('description') : $forum->description}}</textarea>
    @error('description') <span style="color:red">{{$message}}</span>@enderror
</div>
@if($forum->id==0)
<div class="form-group my-2">
    <label for="image">Image</label>
    <input type="file" name="image" id="image" class="form-control" >
    @error('image') <span style="color:red">{{$message}}</span>@enderror
</div> 
@else
<div class="row">
    <div class="col-md-6">
        <div class="form-group my-2">
            <label for="image">Image</label>
            <input type="file" name="image" id="image" class="form-control" >
            @error('image') <span style="color:red">{{$message}}</span>@enderror
        </div> 
    </div>
    <div class="col-md-6">
        <img width="100%" src="{{asset('storage/forum/'.$forum->image)}}" alt="">
    </div>
</div>
@endif
<div class="form-group my-2">
    <label for="date">Date</label>
    <input type="date" name="date" value="{{old('date') ? old('date') : $forum->date}}" id="date" class="form-control" >
    @error('date') <span style="color:red">{{$message}}</span>@enderror
</div>

resources/views/forum/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <h1>Nouveau Forum</h1>
    <form action="{{ route('forum.store') }}" method="POST" enctype="multipart/form-data" class="">
        @csrf
        
        @include('forum._form')
        <input type="submit" value="Enregistrer" class="btn btn-success">
    </form>
</div>
@endsection

resources/views/forum/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <h1>Mise à jour du Forum</h1>
    <form action="{{ route('forum.update', $forum->id) }}" method="POST" enctype="multipart/form-data" class="">
        @csrf
        @method('PUT')
        @include('forum._form')
        <input type="submit" value="Mise à jour" class="btn btn-success">
    </form>
</div>
@endsection

resources/views/forum/index.blade.php
@extends('layouts.app')

@section('content')
    <h1>Listes des forums</h1>
    <a href="{{ route('forum.create') }}" class="btn btn-primary">Ajouter un forum</a>
    <table class="table table-stripped table-bordered">
        <tr>
            <th>#</th>
            <th>Titre</th>
            <th>Description</th>
            <th>Image</th>
            <th>Date</th>
            <th></th>
        </tr>
        @foreach($forums as $key => $f)
        <tr>
            <td>{{$key+1}}</td>
            <td>{{$f->titre}}</td>
            <td>{{$f->description}}</td>
            <td> <img style="width:100px" src="{{ asset('storage/forum/'.$f->image) }}" alt=""> </td>
            <td>{{$f->date}}</td>
            <td>
                <a href="{{route('forum.edit', $f->id)}}" class="btn btn-warning text-white"> <i class="fa fa-pencil"></i> </a>
                <a href="#" onclick="document.getElementById('sup{{$f->id}}').submit()" class="btn btn-danger text-white"> <i class="fa fa-trash"></i> </a>

                <form id="sup{{$f->id}}" action="{{route('forum.destroy', $f->id)}}" method="POST">
                    @csrf
                    @method('DELETE')
                </form>
            </td>
        </tr>
        @endforeach
        
    </table>
    {{$forums->links()}}
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>IST</title>
    <link rel="stylesheet" href="{{ asset('style.css') }}">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>
<body>
    <header>
        <div class="logo">
            <img src="{{asset('images/Logo_IST_mamou.png') }}" alt="">
        </div>
        <nav>
            <ul>
                <li><a href="#">Accueil</a></li>
                <li><a href="#">Forum</a></li>
                <li><a href="#">Contact</a></li>
            </ul>
            <a href="{{ route('login') }}">Connexion</a>
        </nav>
    </header>
    <div class="slider">

    </div>
    <main>
        <h1>Les dernières nouvelles</h1>

        <div class="news">
            @foreach($forums as $k => $forum)
            <a href="{{route('forum.detail', $forum->id)}}" class="new">
                <img src="{{asset('storage/forum/'.$forum->image) }}" alt="">
                <div>
                    <h5>{{$forum->titre}}</h5>
                    <span>  <i class="fa fa-calendar"></i> {{ \Carbon\Carbon::parse($forum->date)->format('d M Y')}}</span>
                </div>
            </a>
            @endforeach
        </div>
    </main>

    <footer>
        &copy; 2023 IST-Mamou. Tous droits réservés.
        
    </footer>
    
</body>
</html>

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
    @yield('css')
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav me-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
    @include('sweetalert::alert')
</body>
</html>